; MMX2 - ett program av BearSoft fr mnniskor som lr sig ASM

; Det hr r ett simpelt programm som scrollar tre bokstver
; upp och ner men inte t samma hll, man kan faktiskt bli
; lite knasig samtidigt som det ser hftigt ut.
; Det bsta av allt r att det r fullt kommenterat p svenska
; fr de som lr sig ASM, men inte frstr de svra engelska orden
; Dessutom innehller programmet all mjlig kod:

; Rita p skrmen
; Lra sig anvnda variabler
; Gra if-satser med fler vgval
; S kallad multitasking (fast nd inte)
; Otroligt ltt att frst

; Tnk p att %0000000 r binra tal
;             $00      r hexadecimala tal
;              00h     ------ | | -----     men fr inte brja med bokstav
;              00d     r decimala tal

#include "asm86.h"         ; Inkluderar headerfiler
#include "ti86asm.inc"

.org $D748                 ; Hr startar asm-programmet

   call  $4AB1             ; Stnger av kr-indikatorn
   call  _clrLCD           ; Tommer skrmen
   CALL  initvars          ; Hoppa till rutinen stll in variabler
loop:
   LD    A, (loopvar)      ; Minskar varabeln loopvar och tittar
   DEC   A                 ; om den har blivit noll, i s  
   LD    (loopvar), A      ; fall avsluta programmet
   CP    00h                
   RET   Z
   HALT                    ; De hr raderna gr en liten paus
   HALT                    ; s att inte programmet blir fr snabbt
   HALT
   HALT
   CALL  movelettre1       ; Hoppa till rutinen flytta bokstav 1
   CALL  paintlettre1      ; Hoppa till rutinen skriv ut bokstav 1
   CALL  movelettre2       ; Hoppa till rutinen flytta bokstav 2
   CALL  paintlettre2      ; Hoppa till rutinen skriv ut bokstav 2
   CALL  movelettre3       ; Hoppa till rutinen flytta bokstav 3
   CALL  paintlettre3      ; Hoppa till rutinen skriv ut bokstav 3
   JR    loop              ; Hoppar tillbaka till loop

initvars:
   LD    A, $FF            
   LD    (loopvar), A      ; Sparar $FF i loopvar (det strsta vrdet = 255)
   LD    A, 00d
   LD    (lettre1), A      ; Sparar 00d i (bokstavs 1 position)
   LD    A, 10d
   LD    (lettre2), A      ; Sparar 00d i (bokstavs 2 position)
   LD    A, 20d
   LD    (lettre3), A      ; Sparar 00d i (bokstavs 3 position)
   LD    A, 00d
   LD    (lettre1dir), A   ; Sparar 00d (=ner) i (bokstavs 1 riktning) 
   LD    (lettre2dir), A   ; Sparar 00d (=ner) i (bokstavs 2 riktning)
   LD    (lettre3dir), A   ; Sparar 00d (=ner) i (bokstavs 3 riktning)
   RET                     ; Hoppa tillbaka dr rutinen anropades

paintlettre1:
   LD    HL, $FC00         ; Lgg addressen till skrmen i HL
   LD    A, (lettre1)      ; Ladda A med bokstavs 1 position
   LD    B, A              ; Ladda B med A (bokstavs 1 position)
paintlettre1loop:
   LD    DE, 16d           ; Den hr loopen multiplicerar 16 med
   ADD   HL, DE            ; lettre1 (bokstavs 1 position) s att
   DJNZ  paintlettre1loop  ; HL pekar dr bokstaven skall skrivas ut
   LD    DE, char_M        ; Ladda DE med addressen till bokstaven M 
   CALL  paintpicture      ; Hoppa till rutinen som skriver ut bokstaven
   RET

movelettre1:
   LD    A, (lettre1dir)   ; Hr r ett vgskl. r lettre1dir (bokstavs 1
   CP    00h               ; riktning) = 00h s hoppar datorn till funktionen
   JR    Z, inclettre1     ; som flyttar bokstaven nedt, annars till funktionen
   JR    declettre1        ; som flyttar bokstaven uppt
movelettre1return:
   RET                     ; Hoppa tillbaka dr rutinen anropades

inclettre1:
   LD    A, (lettre1)      ; kar variablen lettre1 (bokstavs 1 position)
   INC   A                 ; med 1 (=ett steg ner p skrmen)
   LD    (lettre1), A
   CP    33d               ; Jmfr om variablen r 33 (dvs lngst ner p
   CALL  Z, turnlettre1up  ; skrmen) s hoppa till funktionen som ndrar riktning
   JR movelettre1return    ; Hoppa upp till funktionen movelettre1return

turnlettre1up:
   LD    A, 01h            ; Ladda variabeln lettre1dir (bokstavs 1 riktning)
   LD    (lettre1dir), A   ; med 01h (=upp).
   RET                     ; Hoppa tillbaka dr rutinen anropades

declettre1:
   LD    A, (lettre1)      ; Minskar variablen lettre1 (bokstavs 1 position)
   DEC   A                 ; med 1 (=ett steg upp p skrmen)
   LD    (lettre1), A
   CP    01d               ; Jmfr om variablen r 01 (dvs lngst upp p
   CALL  Z, turnlettre1down ; skrmen) s hoppa till funktionen som ndrar riktning
   JR movelettre1return    ; Hoppa upp till funktionen movelettre1return

turnlettre1down:
   LD    A, 00h            ; Ladda variabeln lettre1dir (bokstavs 1 riktning)
   LD    (lettre1dir), A   ; med 00h (=ner).
   RET                     ; Hoppa tillbaka dr rutinen anropades

paintlettre2:
   LD    HL, $FC05         ; Dessa rutiner r identiska med de ovan, skillnaden
   LD    A, (lettre2)      ; r att bokstvernas platser r frskjutna med
   LD    B, A              ; 5 bytes, s att de placeras till hger om fregende
paintlettre2loop:          ; bokstav. 
   LD    DE, 16d
   ADD   HL, DE
   DJNZ  paintlettre2loop
   LD    DE, char_M
   CALL  paintpicture
   RET

movelettre2:
   LD    A, (lettre2dir)
   CP    00h
   JR    Z, inclettre2
   JR    declettre2
movelettre2return:
   RET

inclettre2:
   LD    A, (lettre2)
   INC   A
   LD    (lettre2), A
   CP    33d
   CALL  Z, turnlettre2up
   JR movelettre2return

turnlettre2up:
   LD    A, 01h
   LD    (lettre2dir), A
   RET

declettre2:
   LD    A, (lettre2)
   DEC   A
   LD    (lettre2), A
   CP    01d
   CALL  Z, turnlettre2down
   JR movelettre2return

turnlettre2down:
   LD    A, 00h
   LD    (lettre2dir), A
   RET

paintlettre3:
   LD    HL, $FC0A
   LD    A, (lettre3)
   LD    B, A
paintlettre3loop:
   LD    DE, 16d
   ADD   HL, DE
   DJNZ  paintlettre3loop
   LD    DE, char_X
   CALL  paintpicture
   RET

movelettre3:
   LD    A, (lettre3dir)
   CP    00h
   JR    Z, inclettre3
   JR    declettre3
movelettre3return:
   RET

inclettre3:
   LD    A, (lettre3)
   INC   A
   LD    (lettre3), A
   CP    33d
   CALL  Z, turnlettre3up
   JR movelettre3return

turnlettre3up:
   LD    A, 01h
   LD    (lettre3dir), A
   RET

declettre3:
   LD    A, (lettre3)
   DEC   A
   LD    (lettre3), A
   CP    01d
   CALL  Z, turnlettre3down
   JR movelettre3return

turnlettre3down:
   LD    A, 00h
   LD    (lettre3dir), A
   RET

paintpicture:
   LD    C, 31d            ; Ladda C med 31d (lngden p bokstaven i y-led)
yloop:
   LD    B, 5h             ; Ladda B med 5d (lngden p bokstaven i x-led) 
xloop:                     ; !! Kom ihg att 5 bytes bred r 40 pixlar !!
   LD    A, (DE)           ; Kopiera det som DE pekar p till det som HL
   LD    (HL), A           ; pekar p (HL) = (DE) DE = bild, HL = skrm
   INC   DE                ; kar pekaren DE
   INC   HL                ; kar pekaren HL
   DJNZ  xloop             ; Minskar B, om B r strre n noll s hoppa till xloop
   PUSH  DE                ; Spar undan DE s jag kan anvnda den utan att sabotera det gamla innehllet
   LD    DE, 11d           ; Lgg 11 i DE
   ADD   HL, DE            ; Addera HL med DE. HL blir 11 strre (nsta rad p skrmen)
   POP   DE                ; Hmta tillbaka det undansparade vrdet i DE (Pushar man mste man poppa)
   LD    A, C              ; Hmta C, minska det och lgg tillbaka det
   DEC   A                  
   LD    C, A
   CP    00h               ; Jmfr om C r noll
   JR    NZ, yloop         ; r s inte fallet hoppa tillbaka till yloop
   RET                     ; Hoppa tillbaka dr rutinen anropades

loopvar:                   ; Den variabel som hller reda p nr programmet
   .db 00h                 ; skall avslutas, loopvar = 0 ger avsluta

lettre1:                   ; bokstavs 1 position
   .db 00h

lettre1dir:                ; bokstavs 1 riktning
   .db 00h

lettre2:                   ; bokstavs 2 position
   .db 00h

lettre2dir:                ; bokstavs 2 riktning
   .db 00h

lettre3:                   ; bokstavs 3 position
   .db 00h

lettre3dir:                ; bokstavs 3 riktning
   .db 00h

char_M:                    ; Bilderna av bokstverna (det hr r M)

   .db %00000000, %00000000, %00000000, %00000000, %00000000
   .db %11111111, %11100000, %00000000, %00000111, %11111110
   .db %11111111, %11110000, %00000000, %00001111, %11111110
   .db %00111111, %11110000, %00000000, %00001111, %11111000
   .db %00001111, %11111000, %00000000, %00001111, %11100000
   .db %00001111, %11111000, %00000000, %00011111, %11100000
   .db %00001111, %11111000, %00000000, %00011111, %11100000
   .db %00001111, %11111100, %00000000, %00111111, %11100000
   .db %00001110, %11111100, %00000000, %00110111, %11100000
   .db %00001110, %11111110, %00000000, %01110111, %11100000
   .db %00001110, %01111110, %00000000, %01100111, %11100000
   .db %00001110, %01111111, %00000000, %01100111, %11100000
   .db %00001110, %00111111, %00000000, %11000111, %11100000
   .db %00001110, %00111111, %10000000, %11000111, %11100000
   .db %00001110, %00011111, %10000001, %10000111, %11100000
   .db %00001110, %00011111, %11000001, %10000111, %11100000
   .db %00001110, %00011111, %11000011, %10000111, %11100000
   .db %00001110, %00001111, %11100011, %00000111, %11100000
   .db %00001110, %00001111, %11100111, %00000111, %11100000
   .db %00001110, %00000111, %11110110, %00000111, %11100000
   .db %00001110, %00000111, %11110110, %00000111, %11100000
   .db %00001110, %00000011, %11111100, %00000111, %11100000
   .db %00001110, %00000011, %11111100, %00000111, %11100000
   .db %00001110, %00000001, %11111000, %00000111, %11100000
   .db %00001110, %00000001, %11111000, %00000111, %11100000
   .db %00001110, %00000000, %11111000, %00000111, %11100000
   .db %00001111, %00000000, %11110000, %00000111, %11100000
   .db %00111111, %10000000, %11110000, %00011111, %11111000
   .db %11111111, %11100000, %01100000, %01111111, %11111110
   .db %11111111, %11100000, %01100000, %01111111, %11111110
   .db %00000000, %00000000, %00000000, %00000000, %00000000

char_X:                    ; Bilderna av bokstverna (Det hr r X)

   .db %00000000, %00000000, %00000000, %00000000, %00000000
   .db %11111111, %11111100, %00011111, %11111110, %00111100
   .db %11111111, %11111100, %00011111, %11111110, %01001110
   .db %00011111, %11100000, %00000001, %11110000, %10000110
   .db %00001111, %11110000, %00000001, %11000000, %10000110
   .db %00000111, %11110000, %00000011, %10000000, %00000110
   .db %00000011, %11111000, %00000011, %10000000, %00001100
   .db %00000001, %11111100, %00000111, %00000000, %00001000
   .db %00000001, %11111110, %00001110, %00000000, %00010000
   .db %00000000, %11111110, %00011100, %00000000, %00100000
   .db %00000000, %01111111, %00111000, %00000000, %01000010
   .db %00000000, %00111111, %11110000, %00000000, %11111110
   .db %00000000, %00111111, %11100000, %00000000, %00000000
   .db %00000000, %00011111, %11000000, %00000000, %00000000
   .db %00000000, %00001111, %11100000, %00000000, %00000000
   .db %00000000, %00000111, %11110000, %00000000, %00000000
   .db %00000000, %00000111, %11111000, %00000000, %00000000
   .db %00000000, %00001111, %11111000, %00000000, %00000000
   .db %00000000, %00011101, %11111100, %00000000, %00000000
   .db %00000000, %00111000, %11111110, %00000000, %00000000
   .db %00000000, %00110000, %11111111, %00000000, %00000000
   .db %00000000, %01110000, %01111111, %00000000, %00000000
   .db %00000000, %11100000, %00111111, %10000000, %00000000
   .db %00000001, %11000000, %00011111, %11000000, %00000000
   .db %00000011, %10000000, %00011111, %11100000, %00000000
   .db %00000111, %00000000, %00001111, %11100000, %00000000
   .db %00000111, %00000000, %00000111, %11110000, %00000000
   .db %00011111, %10000000, %00001111, %11111000, %00000000
   .db %11111111, %11110000, %01111111, %11111111, %00000000
   .db %11111111, %11110000, %01111111, %11111111, %00000000
   .db %00000000, %00000000, %00000000, %00000000, %00000000

.end                       ;Hr slutar all kodning

